#include "XAudio.h"

int XAudio::ReferenceCounter = 0;
IXAudio2* XAudio::pXAudio2 = NULL;
IXAudio2MasteringVoice* XAudio::pMasteringVoice = NULL;

XAudio* _pXAudioSingleton_ = NULL;

#ifdef _DEBUG
#pragma comment( lib, "xapobased.lib" )
#else
#pragma comment( lib, "xapobase.lib" )
#endif

XAudio& XAudio::GetInstance()
{
	if( !_pXAudioSingleton_ ){
		_pXAudioSingleton_ = new XAudio();

		CoInitializeEx( NULL, COINIT_MULTITHREADED );

		UINT32 flags = 0;
	#ifdef _DEBUG
		flags |= XAUDIO2_DEBUG_ENGINE;
	#endif

		if( FAILED( XAudio2Create( &pXAudio2, flags ) ) ){
			CoUninitialize();
			MessageBoxA( NULL, "Failed: XAudio::XAudio2Create DirectX̃o[WÂ\܂BNovember 2008ȍ~̃o[WDirectXCXg[ĉB", "Error", MB_OK );
		}

		if( FAILED( pXAudio2->CreateMasteringVoice( &pMasteringVoice ) ) ){
			XAD_SAFE_RELEASE( pXAudio2 );
			CoUninitialize();
			MessageBoxA( NULL, "Failed: XAudio::CreateMasteringVoice", "Error", MB_OK );
		}
	}

	return *_pXAudioSingleton_;
}

bool XAudio::Release()
{
	if( _pXAudioSingleton_ ){
		if( pMasteringVoice ) pMasteringVoice->DestroyVoice();
		XAD_SAFE_RELEASE( pXAudio2 );

		CoUninitialize();

		delete _pXAudioSingleton_;
		_pXAudioSingleton_ = NULL;
	}

	return true;
}
